/////////////////////////////////////////////////
//            MY CIENAGA V 1.04
////////////////////////////////////////////////

/*Pines(I/O) 
 D0 - 
 D1 - PANTALLA LCD
 D2 - SONDA TEMPERATURA            
 D3 - LED BLANCO 1 PWM             
 D4 - RELE 1 ENCENDIDO FUENTE          
 D5 - LED BLANCO 2 PWM             
 D6 - LED AZUL    PWM             
 D7 - RELE 3 OXIGENADOR
 D8 - RELE 2 CO2
 D9 - VENTILADORES FOCOS PWM 
 D10 -LED ROJO    PWM
 D11 -  
 D12 -RELE 4 VENTILADOR FRONTAL                                
 D13 - 
 A0 - BOTON 1 (MENU-INFO-MANTENIMIENTO)
 A1 - 
 A2 - lcontrolv                      
 A3 - lcontrolr                             
 A4 - BUS I2C-SDA RELOJ            
 A5 - BUS I2C-SCL RELOJ           
 
 SENSORES TEMPERATURA, LEDS (0,1) ACUARIO (2)
 
 
 MENUS BOTONES
 
 -PULSANDO 1 VEZ BOTON MENU (//info//lcd)
 -PULSANDO SIN SOLTAR BOTON MENU (PAUSA)
 -PULSANDO 1 VEZ BOTON SELECCION (MANTENIMIENTO --> BOMBA RETORNO+BOMBA MOVIMIENTO OFF)
 -PULSANDO SIN SOLTAR BOTON SELECCION (MENU RELES)
 -PULSANDO BOTON1 Y BOTON2 (AJUSTE FECHA Y HORA)
*/ 





#include <avr/io.h>               //lcd  
#include <stdlib.h>               //lcd
#include <OneWire.h>              //temperatura
#include <DallasTemperature.h>    //temperatura
#include <Wire.h>                 //I2C
#include <EEPROM.h>              //LIBRERIA



//Variables
#define ONE_WIRE_BUS 2         //temperatura
OneWire oneWire(ONE_WIRE_BUS);//temperatura
DallasTemperature sensors(&oneWire);

#define DS1307_I2C_ADDRESS 0x68
#define CR 250            //lcd
#define CD 1              //lcd

#define boton  A0 
// pines A4 Y A5 son usados para el bus IC2 (memoria EEPROM, RELOJ)
// pin A4 - SDA - IC2  (pin 20 en Arduino Mega)
// pin A5 - SCL - IC2  (pin 21)

//Pines OUTPUT DIGITALES

// pines 0 y 1 usados para el bus SERIAL RS232 - LCD
// pin 2 es usado para el bus 1-Wire (OneWire Sondas de temperatura)

#define lblanco   3
#define rele1     4
#define lblanco2  5
#define lazul     6
#define rele3     7
#define rele2     8
#define ventiladores  9
#define lrojo     10
#define rele4     12

//Pines OUTPUT Analogicos?

#define lcontrolv  16
#define lcontrolr  17

// VARIALES DEL PROGRAMA

  // Variables de estado

  int estadoMenu = 0; // Guarda el estado del menu entre llamadas a la funcion menu
  int refrescarLCD = 1; // Indica que se ha de actualizar los datos mostrados en la pantalla
  int faseluz = 0;

 // Variables de memoria intermedia

  int vventilador = 0;//Valor ventilador 1
  byte vhora = 0;      //Valor Hora
  byte vminuto = 0;    //Valor minuto
  byte vsegundo = 0;   //Valor segundo
  static unsigned long vmillis = 0; //tiempo en milisegundos
 
 char* cienaga = "MY CIENAGA";

  // Variables para control del tiempo

  byte second, minute, hour, dayOfWeek, dayOfMonth, month, year;
  int tiempo; // la hora actual calculada en minutos

  //   Variables para reles (horas y minutos) se guarda una copia de estas variables en la eeprom, para recuperarlas en fallo de alimentacion

  int rel1on;
  int rel1off;
  int rel1minon;
  int rel1minoff;
  
  int rel2on;
  int rel2off;
  int rel2minon;
  int rel2minoff;
  
  int rel3on;
  int rel3off;
  int rel3minon;
  int rel3minoff;
  
  int rel4on;
  int rel4off;
  int rel4minon;
  int rel4minoff;

//Posiciones de la memoria EEPROM donde guardaremos las horas y minutos de los reles (1 posicion = 1 BYTE)

  #define rel1_on      1               
  #define rel1_off     2                  
  #define rel1_min_on  3                 
  #define rel1_min_off 4                  
  #define rel2_on      5                 
  #define rel2_off     6                 
  #define rel2_min_on  7                 
  #define rel2_min_off 8                  
  #define rel3_on      9
  #define rel3_off     10
  #define rel3_min_on  11
  #define rel3_min_off 12
  #define rel4_on      13
  #define rel4_off     14
  #define rel4_min_on  15
  #define rel4_min_off 16

// Variables de sondas (ventiladores) se guarda una copia de estas variables en la eeprom, para recuperarlas en fallo de alimentacion
  
///////////////AJUSTE SONDAS PANTALLA
  
  int sondpanon;
  int sondpanoff;
  
//////////////AJUSTE SONDA CAJA  
  
  int sondcajon;
  int sondcajoff;
  
//Posiciones de la memoria EEPROM donde guardaremos las temperaturas para el funcionamiento de los ventiladores 

  #define sond_pan_on         17                 //Aqui almacenaremos la temperatura de encendido de pantalla
  #define sond_pan_off        18                 //Aqui almacenaremos la temperatura de apagado de pantalla
  #define sond_caj_on         19                 //Aqui almacenaremos la temperatura de encendido de caja
  #define sond_caj_off        20                 //Aqui almacenaremos la temperatura de apagado de caja
  
// Variables de sondas (led) se guarda una copia de estas variables en la eeprom, para recuperarlas en fallo de alimentacion
  
  int sondonplus;
  int sondoffplus;
      
  int errortempon;
  int errortempoff;

//Posiciones de la memoria EEPROM donde guardaremos las temperaturas para el funcionamiento de los LED 

  #define sond_on_plus        21
  #define sond_off_plus       22
  #define error_temp_on       23
  #define error_temp_off      24


//Variables para almacenar MOSTRAR las temperaturas de las sondas en tiempo real

  float t0 = 0;
  float t1 = 0;
  float t2 = 0;
  float t3 = 0;
  float t4 = 0;
  float t5 = 0;

  int lsond = 0;

///SETUP////
void setup()
{
  
  //Se inician los diferentes buses de comunicacion //
  
  Wire.begin();//I2C
  Serial.begin(9600);//LCD
  sensors.begin();//Temperatura
  
  //digitalWrite(rele1,HIGH);  
  p();  
  LCD_Reset(1); 
 
 
  
 //Control de pines I/O//
 
  
  pinMode(lblanco,OUTPUT);// LED BLANCO PWM 
  pinMode (rele1, OUTPUT);// FUENTE ALIMENTACION ON/OFF
  pinMode (lblanco2,OUTPUT);// LED BLANCOS 2 PWM
  pinMode (lazul, OUTPUT);// LED AZUL PWM
  pinMode (rele3, OUTPUT);// OXIGENADOR ON/OFF
  pinMode (rele2, OUTPUT);// CO2 ON/OFF
  pinMode (lrojo, OUTPUT);// LED ROJO PWM
  pinMode (rele4, OUTPUT);// VENTILADOR FRONTAL
  pinMode (ventiladores, OUTPUT);// VENTILADORES FOCOS PWM
  pinMode (boton, INPUT);     //Pin de botones
  pinMode (lcontrolr, OUTPUT);// LED CONTROL ROJO
  pinMode(lcontrolv,OUTPUT);// LED CONTROL VERDE
  
  //   Cargamos las especificaciones para reles guardados en la EEPROM

  rel1on     = EEPROM.read(rel1_on);
  rel1off    = EEPROM.read(rel1_off);
  rel1minon  = EEPROM.read(rel1_min_on);
  rel1minoff = EEPROM.read(rel1_min_off);
  rel2on     = EEPROM.read(rel2_on);
  rel2off    = EEPROM.read(rel2_off);
  rel2minon  = EEPROM.read(rel2_min_on);
  rel2minoff = EEPROM.read(rel2_min_off);
  rel3on     = EEPROM.read(rel3_on);
  rel3off    = EEPROM.read(rel3_off);
  rel3minon  = EEPROM.read(rel3_min_on);
  rel3minoff = EEPROM.read(rel3_min_off);
  rel4on     = EEPROM.read(rel4_on);
  rel4off    = EEPROM.read(rel4_off);
  rel4minon  = EEPROM.read(rel4_min_on);
  rel4minoff = EEPROM.read(rel4_min_off);
  
 // Cargamos las especificaciones para las sondas para ventiladores guardados en la EEPROM
  
  sondpanon      = EEPROM.read(sond_pan_on);
  sondpanoff     = EEPROM.read(sond_pan_off);
  sondcajon      = EEPROM.read(sond_caj_on);
  sondcajoff     = EEPROM.read(sond_caj_off);
    
   // Cargamos las especificaciones para las sondas para led guardados en la EEPROM
    
  sondonplus  = EEPROM.read(sond_on_plus);
  sondoffplus  = EEPROM.read(sond_off_plus);
  errortempon  = EEPROM.read(error_temp_on);
  errortempoff = EEPROM.read(error_temp_off);
  
  //Para evitar que nada mas ecender el control pase por el bucle ya que da problemas de sondas lecturas raras
  LCD_Reset(1); 
  p();p(); 
  setCur(0,1); Serial.print("Inicializando ");
  setCur(0,2); Serial.print("Dispositivos Cienaga"); 
  p(); // esperamos un tiempo de 3 segundos, antes de arrancar el bucle principal, con esto se estabilizan las sondas despues del encendido.
  setCur(0,1); Serial.print("               ");
  setCur(0,2); Serial.print("                    "); 

  
   /*
  // la primera vez debemos poner en hora, active esta parte y luego vuelva a quitarla
  second = 00;
  minute = 03;
  hour = 23;
  dayOfWeek = 3;
  dayOfMonth = 30;
  month = 11;
  year = 10;
  
  setDateDs1307(second, minute, hour, dayOfWeek, dayOfMonth, month, year); 
  */
  
 
}

//Entramos en el bucle de codigo principal
void loop()                     
{

  getDateDs1307(&second, &minute, &hour, &dayOfWeek, &dayOfMonth, &month, &year); // LEEMOS LA HORA;

  // ESTO LO REALIZARA UNA VEZ CADA SEGUNDO
  if (vsegundo != second) {
    vsegundo = second;
    refrescarLCD = 1;
    ledvflash();
    LeerValoresSondas(); // Esto hace que las variables t0 a t5 tengan los valores de las sondas actualizados cada segundo 
                         // (si se saca de aqui se pude hacer que se actualicen mas rapido)
    }
    
  // ESTAS SENTENCIAS LAS HACE SOLO 1 VEZ POR MINUTO
  if (vminuto != minute){
      vminuto=minute;
     }

  // ESTAS SENTENCIAS LAS HACE SOLO 1 VEZ A LA HORA DE 8:00 A 23:00
  if (vhora !=hour){
      vhora=hour;
      }  

  //fecha(0);   //Pintamos hora / fecha / nombre-CIENAGA en la linea 0
  //infolcd();  //Estructura general de la pantalla principal
  Menu();  //Ejecutamos el menu (que ya se ocupa de fecha(0) y de infolcd()
  ctemp();    //Control de temperatura
  reles();    //Control de reles
   
}

// FUNCIONES ////////////////////////////////////////////////////// LIBRERIA PROPIA

/*int EEPROM_writeFloat(int ee, const float& value)
{
    const byte* p = (const byte*)(const void*)&value;
    unsigned int i;
    for (i = 0; i < sizeof(value); i++)
          EEPROM.write(ee++, *p++);
    return i;
}

int EEPROM_readFloat(int ee, float& value)
{
    byte* p = (byte*)(void*)&value;
    unsigned int i;
    for (i = 0; i < sizeof(value); i++)
          *p++ = EEPROM.read(ee++);
    return i;
}
*/
//Recuperamos los valores de temperatura
//Aqui habrá que almacenarlos en una variable para actuar sobre el rele del termostato


// Convierte números normales decimales a BCD (binario decimal codificado)
byte decToBcd(byte val)
{
  return ( (val/10*16) + (val%10) );
}

// Convierte BCD (binario decimal codificado) a números normales decimales 
byte bcdToDec(byte val)
{
  return ( (val/16*10) + (val%16) );
}

// 1) Sets the date and time on the ds1307
// 2) Starts the clock
// 3) Sets hour mode to 24 hour clock

void setDateDs1307(byte second,        // 0-59
                   byte minute,        // 0-59
                   byte hour,          // 1-23
                   byte dayOfWeek,     // 1-7
                   byte dayOfMonth,    // 1-28/29/30/31
                   byte month,         // 1-12
                   byte year)          // 0-99
  {
   Wire.beginTransmission(DS1307_I2C_ADDRESS);
   Wire.send(0);
   Wire.send(decToBcd(second));    
   Wire.send(decToBcd(minute));
   Wire.send(decToBcd(hour));      
   Wire.send(decToBcd(dayOfWeek));
   Wire.send(decToBcd(dayOfMonth));
   Wire.send(decToBcd(month));
   Wire.send(decToBcd(year));
   Wire.endTransmission();
  }

// Establece la fecha y la hora del reloj
void getDateDs1307(byte *second,
          byte *minute,
          byte *hour,
          byte *dayOfWeek,
          byte *dayOfMonth,
          byte *month,
          byte *year)
  {
  // Resetea el registro puntero
  Wire.beginTransmission(DS1307_I2C_ADDRESS);
  Wire.send(0);
  Wire.endTransmission();

  Wire.requestFrom(DS1307_I2C_ADDRESS, 7);

  // Alguno de estos necesitan enmascarar porque ciertos bits son bits de control	

  *second     = bcdToDec(Wire.receive() & 0x7f);
  *minute     = bcdToDec(Wire.receive());
  *hour       = bcdToDec(Wire.receive() & 0x3f);  
  *dayOfWeek  = bcdToDec(Wire.receive());
  *dayOfMonth = bcdToDec(Wire.receive());
  *month      = bcdToDec(Wire.receive());
  *year       = bcdToDec(Wire.receive());
  tiempo = ((*hour) << 6) | (*minute);

}


   
// Pausa 3 segundos
void p ()
{ 
  delay (3000);
}

// Led verde parpadea
void ledvflash()
{
  int ledv = digitalRead(lcontrolv);
  if (ledv == HIGH) digitalWrite(lcontrolv, LOW); 
  else digitalWrite(lcontrolv, HIGH);
}

// Led verde control on
void ledvon()
{
  digitalWrite(lcontrolv, HIGH);
}

// Led verde control off
void ledvoff()
{
  digitalWrite(lcontrolv, LOW);
}  

// Led rojo control on
void ledron()
{
  
  digitalWrite(lcontrolr, HIGH);
}

// Led rojo control off
void ledroff()
{
  digitalWrite(lcontrolr, LOW);
}  


void setCur( uint8_t ln, uint8_t row ){

  uint8_t lnP;

  switch (row) {
  case 0:
    lnP = 0x80 | ln;  
    break;
  case 1:
    lnP = 0xC0 | ln;
    break;
  case 2: 
    lnP = 0x80 | (ln + 20); 
    break;
  case 3:
    lnP = 0xC0 | (ln + 20);
  }
   
  Serial.write(CR);
  Serial.write(lnP);
}


void clearDisp(){
  
  Serial.write(CR);
  Serial.write(CD);
  
}

void LCD_Reset(uint8_t inter) //inter is for interface: 0 for SPI: 1 for RS232
{
  Comm(0b00110000,inter);
  delay(5);
  Comm(0b00110000,inter);
  delayMicroseconds(100); 
  Comm(0b00110000,inter);
  Comm(0b00111000,inter); 
  Comm(0b00001100,inter);
  Comm(0b00000001,inter); 
  Comm(0b00000110,inter); 
}

void Comm(uint8_t mval, uint8_t inter){
  if (inter == 0){    
  }
  if (inter == 1){  
    Serial.write(CR);
    Serial.write(mval);  
  }
}


